var search_data = {"index":{"searchIndex":["injectable","classmethods","dependenciesgraph","dependenciesproxy","instancemethods","methodalreadyexistsexception","missingdependenciesexception","add()","argument()","call()","call()","check_call_definition!()","check_for_missing_dependencies!()","check_missing_arguments!()","dependencies_of()","dependencies_proxy()","dependency()","extended()","find_required_arguments()","get()","included()","inherited()","initialize_with()","memoized_dependencies_of()","names()","new()","new()","new()","proxy()","required_call_arguments()","required_initialize_arguments()","simple_class_attribute()","variables_for!()","variables_from_dependencies!()","with_namespace()"],"longSearchIndex":["injectable","injectable::classmethods","injectable::dependenciesgraph","injectable::dependenciesproxy","injectable::instancemethods","injectable::methodalreadyexistsexception","injectable::missingdependenciesexception","injectable::dependenciesgraph#add()","injectable::classmethods#argument()","injectable::classmethods#call()","injectable::instancemethods#call()","injectable::instancemethods#check_call_definition!()","injectable::dependenciesgraph#check_for_missing_dependencies!()","injectable::instancemethods#check_missing_arguments!()","injectable::dependenciesproxy#dependencies_of()","injectable::instancemethods#dependencies_proxy()","injectable::classmethods#dependency()","injectable::classmethods::extended()","injectable::classmethods#find_required_arguments()","injectable::dependenciesproxy#get()","injectable::included()","injectable::classmethods#inherited()","injectable::classmethods#initialize_with()","injectable::dependenciesproxy#memoized_dependencies_of()","injectable::dependenciesgraph#names()","injectable::dependenciesgraph::new()","injectable::dependenciesproxy::new()","injectable::instancemethods::new()","injectable::dependenciesgraph#proxy()","injectable::classmethods#required_call_arguments()","injectable::classmethods#required_initialize_arguments()","injectable::classmethods#simple_class_attribute()","injectable::instancemethods#variables_for!()","injectable::instancemethods#variables_from_dependencies!()","injectable::dependenciesgraph#with_namespace()"],"info":[["Injectable","","Injectable.html","","<p>Convert your class into an injectable service\n<p>@example\n\n<pre>You would create a service like this:\n\nclass AddPlayerToTeamRoster ...</pre>\n"],["Injectable::ClassMethods","","Injectable/ClassMethods.html","",""],["Injectable::DependenciesGraph","","Injectable/DependenciesGraph.html","","<p>Holds the dependency signatures of the service object\n"],["Injectable::DependenciesProxy","","Injectable/DependenciesProxy.html","","<p>Memoizes the Dependencies generated by Dependency based on DependencyGraph\n"],["Injectable::InstanceMethods","","Injectable/InstanceMethods.html","",""],["Injectable::MethodAlreadyExistsException","","Injectable/MethodAlreadyExistsException.html","",""],["Injectable::MissingDependenciesException","","Injectable/MissingDependenciesException.html","",""],["add","Injectable::DependenciesGraph","Injectable/DependenciesGraph.html#method-i-add","(name:, depends_on:, **kwargs)","<p>Adds the signature of a dependency to the graph\n"],["argument","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-argument","(name, options = {})","<p>Declare the arguments for `#call` and initialize the accessors This helps us clean up the code for memoization: …\n"],["call","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-call","(args = {})","<p>Use the service with the params declared with &#39;.argument&#39; @param args [Hash] parameters needed …\n"],["call","Injectable::InstanceMethods","Injectable/InstanceMethods.html#method-i-call","(args = {})","<p>Entry point of the service. Arguments for this method should be declared explicitly with &#39;.argument&#39; …\n"],["check_call_definition!","Injectable::InstanceMethods","Injectable/InstanceMethods.html#method-i-check_call_definition-21","()",""],["check_for_missing_dependencies!","Injectable::DependenciesGraph","Injectable/DependenciesGraph.html#method-i-check_for_missing_dependencies-21","(deps)",""],["check_missing_arguments!","Injectable::InstanceMethods","Injectable/InstanceMethods.html#method-i-check_missing_arguments-21","(expected, args)",""],["dependencies_of","Injectable::DependenciesProxy","Injectable/DependenciesProxy.html#method-i-dependencies_of","(name)",""],["dependencies_proxy","Injectable::InstanceMethods","Injectable/InstanceMethods.html#method-i-dependencies_proxy","()",""],["dependency","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-dependency","(name, options = {}, &block)","<p>Declare dependencies for the service @param name [Symbol] the name of the service @option options [Class] …\n"],["extended","Injectable::ClassMethods","Injectable/ClassMethods.html#method-c-extended","(base)",""],["find_required_arguments","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-find_required_arguments","(hash)",""],["get","Injectable::DependenciesProxy","Injectable/DependenciesProxy.html#method-i-get","(name)","<p>Get the instance of the dependency <code>name</code>\n"],["included","Injectable","Injectable.html#method-c-included","(base)",""],["inherited","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-inherited","(base)",""],["initialize_with","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-initialize_with","(name, options = {})",""],["memoized_dependencies_of","Injectable::DependenciesProxy","Injectable/DependenciesProxy.html#method-i-memoized_dependencies_of","(name)",""],["names","Injectable::DependenciesGraph","Injectable/DependenciesGraph.html#method-i-names","()",""],["new","Injectable::DependenciesGraph","Injectable/DependenciesGraph.html#method-c-new","(namespace:, proxy_class: ::Injectable::DependenciesProxy, dependency_class: ::Injectable::Dependency)",""],["new","Injectable::DependenciesProxy","Injectable/DependenciesProxy.html#method-c-new","(graph:, namespace: nil)",""],["new","Injectable::InstanceMethods","Injectable/InstanceMethods.html#method-c-new","(args = {})","<p>Initialize the service with the dependencies injected\n"],["proxy","Injectable::DependenciesGraph","Injectable/DependenciesGraph.html#method-i-proxy","()",""],["required_call_arguments","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-required_call_arguments","()","<p>Get the #call arguments declared with &#39;.argument&#39; with no default @private\n"],["required_initialize_arguments","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-required_initialize_arguments","()","<p>Get the #initialize arguments declared with &#39;.initialize_with&#39; with no default @private\n"],["simple_class_attribute","Injectable::ClassMethods","Injectable/ClassMethods.html#method-i-simple_class_attribute","(*attrs)","<p>Blatantly stolen from rails&#39; ActiveSupport. This is a simplified version of class_attribute\n"],["variables_for!","Injectable::InstanceMethods","Injectable/InstanceMethods.html#method-i-variables_for-21","(subject, args)",""],["variables_from_dependencies!","Injectable::InstanceMethods","Injectable/InstanceMethods.html#method-i-variables_from_dependencies-21","(args)",""],["with_namespace","Injectable::DependenciesGraph","Injectable/DependenciesGraph.html#method-i-with_namespace","(namespace)",""]]}}